"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
// 弹幕库实例
var Danmaku = /** @class */ (function () {
    function Danmaku(canvas, danmakuConfig) {
        this.isPause = false;
        this.lastRenderTime = 0;
        this.mDanmuTracks = new Array();
        this.mCanvas = canvas;
        this.mDanmukuConfig = danmakuConfig;
        this.mCtx = canvas.getContext('2d');
        this.initRender();
    }
    Danmaku.prototype.addDanmuTrack = function (danmuTrack) {
        this.mDanmuTracks.push(danmuTrack);
        danmuTrack.setDanmaku(this);
    };
    Danmaku.prototype.removeDanmuTrack = function (danmuTrack) {
        this.mDanmuTracks = this.mDanmuTracks.filter(function (item) { return item !== danmuTrack; });
    };
    Danmaku.prototype.initRender = function () {
        this.mCanvas.width = this.mDanmukuConfig.width;
        this.mCanvas.height = this.mDanmukuConfig.height;
        if (window.requestAnimationFrame) {
            this.renderByAnimationFrame();
        }
        else {
            this.renderBySetInterval();
        }
    };
    Danmaku.prototype.renderByAnimationFrame = function () {
        this.render();
        requestAnimationFrame(this.renderByAnimationFrame.bind(this));
    };
    Danmaku.prototype.renderBySetInterval = function () {
        setInterval(this.render.bind(this), 0);
    };
    Danmaku.prototype.render = function () {
        if (this.isPause)
            return;
        // let currentTime = new Date().getTime()
        // if (currentTime - this.lastRenderTime < 8) {
        //  return
        // }
        // this.lastRenderTime = currentTime
        this.mCtx.clearRect(0, 0, this.mCanvas.width, this.mCanvas.height);
        for (var _i = 0, _a = this.mDanmuTracks; _i < _a.length; _i++) {
            var mDanmuTrack = _a[_i];
            mDanmuTrack.render(this.mCtx);
        }
    };
    Danmaku.prototype.start = function () {
        this.isPause = false;
    };
    Danmaku.prototype.pause = function () {
        this.isPause = true;
    };
    return Danmaku;
}());
exports.default = Danmaku;
//# sourceMappingURL=Danmaku.js.map