"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var DanmakuPool = /** @class */ (function () {
    function DanmakuPool(size) {
        this.mPoolSize = 20;
        this.mMessagePool = new Array(this.mPoolSize);
        if (size) {
            this.mPoolSize = size;
            this.mMessagePool = new Array(this.mPoolSize);
        }
    }
    DanmakuPool.prototype.addMessage = function (msg) {
        this.addMessages([msg]);
    };
    DanmakuPool.prototype.getMessage = function () {
        var result = null;
        for (var i = 0; i < this.mMessagePool.length; i++) {
            if (this.mMessagePool[i] && this.mMessagePool[i].created) {
                result = this.mMessagePool[i];
                this.mMessagePool[i] = null;
                break;
            }
        }
        return result;
    };
    DanmakuPool.prototype.addMessages = function (msgs) {
        if (msgs === void 0) { msgs = []; }
        for (var i = 0; i < msgs.length; i++) {
            for (var j = 0; j < this.mMessagePool.length; j++) {
                if (!this.mMessagePool[j]) {
                    this.mMessagePool[j] = msgs[i];
                    if (this.mMessagePool[j])
                        this.mMessagePool[j].onBaseCreate();
                    break;
                }
            }
        }
    };
    DanmakuPool.prototype.removeMessage = function (msg) {
        var index = this.mMessagePool.findIndex(function (item) { return item === msg; });
        this.removeMessageByIndex(index);
    };
    DanmakuPool.prototype.removeMessageByIndex = function (index) {
        if (Number.isInteger(index) && index > 0) {
            this.mMessagePool[index] = null;
        }
    };
    return DanmakuPool;
}());
exports.DanmakuPool = DanmakuPool;
//# sourceMappingURL=DanmakuPool.js.map